<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Functions for PSTN entries
 *
 * @author miguel
 */
class HelperPstn {

    //Port section title (PSTN popups)
    static function title($ba, $gr, $lif) {
        $query = $ba->select("select distinct type from isdn where lif='" . $lif . "' union select distinct type from gsm where lif='" . $lif . "' union select distinct type from analog where lif='" . $lif . "' union select distinct type from cas where lif='" . $lif . "'");
        $title = "<b>Li" . $lif . "()</b>";
        while ($entry = $ba->fetch_array($query)) {
            $title = "<b>Li" . $lif . "(" . $entry['type'] . ")</b>";
        }
        return $title;
    }

    //Ports of the port section (PSTN popups)
    static function ports($ba, $gr, $lif, $table) {
        $where = "";
        if ($table == "isdn" || $table == "analog") {
            $where = " and port_type='" . $_GET['opt'] . "'";
        }
        $query = $ba->select("select * from " . $table . " where lif='" . $lif . "' " . $where);
        while ($entry = $ba->fetch_array($query)) {
            $type = explode("-", $entry['type']);
            if ($entry['gr'] == $gr) {
                $tab .= "<div>Port " . $entry['port'] . "<input type='checkbox' name='ports[]' checked value='" . $entry['port'] . "'></div>";
            } elseif ($entry['gr'] == 'NULL') {
                $tab .= "<div>Port " . $entry['port'] . "<input type='checkbox' name='ports[]' value='" . $entry['port'] . "'></div>";
            } else {
                $tab .= "<div>Port " . $entry['port'] . "<input type='checkbox' name='ports[]' checked disabled='true' value='" . $entry['port'] . "'></div>";
            }
        }
        return $tab;
    }

    //Build tones dropdown
    function tones($ba, $gr, $table) {
        $query = $ba->select("select tones from " . $table . " where gr='" . $gr . "'");
        $tones = "";
        while ($entry = $ba->fetch_array($query)) {
            $tones = $entry['tones'];
        }
        exec('/bin/cat /usr/conf/isgw.tones | /bin/grep "^\[.*\]$" ', $ausgabe);
        $ret = "<select name='tones'>";
        foreach ($ausgabe as $value) {
            if ($value == $tones) {
                $ret.="<option value='" . $value . "' selected>" . $value . "</option>";
            } elseif ($value == "[de]" && $gr == "") {
                $ret.="<option value='" . $value . "' selected>" . $value . "</option>";
            } elseif ($value != "[general]") {
                $ret.="<option value='" . $value . "'>" . $value . "</option>";
            }
        }
        $ret.="</select>";
        return $ret;
    }

    //Return text field
    static function textfield($ba, $gr, $col, $table, $default = "") {
        if ($gr != "") {
            $query = $ba->select("select " . $col . " from " . $table . " where gr='" . $gr . "'");
            $value = "";
            while ($entry = $ba->fetch_array($query)) {
                $value = $entry[$col];
            }

            $ret = "<input name='" . $col . "' id='" . $col . "' value='" . $value . "'>";
            return $ret;
        } else {
            $ret = "<input name='" . $col . "' id='" . $col . "' value='" . $default . "'>";
            return $ret;
        }
    }

    //Return a dropdown field
    static function dropdown($ba, $gr, $col, $table, $options, $default = "") {
        $query = $ba->select("select distinct " . $col . " from " . $table . " where gr='" . $gr . "'");
        $sel.="<select name='" . $col . "'>";
        while ($entry = $ba->fetch_array($query)) {
            $default = $entry[$col];
        }
        foreach ($options as $name => $value) {
            ($name == $default) ? $sel.= "<option value='" . $name . "' selected>" . $value . "</option>" : $sel.= "<option value='" . $name . "'>" . $value . "</option>";
        }
        $sel.="</select>";
        return $sel;
    }

    //Return a checkbox
    static function checkbox($ba, $gr, $col, $table, $htmlOptions='', $default = "") {
        $query = $ba->select("select " . $col . " from " . $table . " where gr='" . $gr . "'");
        while ($entry = $ba->fetch_array($query)) {
            if ($entry[$col] == 1)
                $default = "checked";
            else
                $default = "";
        }
        
        $ret = "<input type='hidden' name='$col' value='0'>"
                . "<input type='checkbox' name='$col' id='$col'  value='1' $default $htmlOptions>";
        return $ret;
    }

    //Default config
    function showdefmc($config_values, $letter, $table) {
        $isgw = new isgwtelnet();
        $result = $isgw->isgw_login();
        if ($result != false) {
            $dialplanc = $isgw->isgw_dialplanconfig();
            $zeilen = explode("\n", $dialplanc);
            foreach ($zeilen as $zeile) {
                if (stripos($zeile, '[') === 0) {
                    preg_match("/\[(?<bez>.+)\]\[(?<name>.+)\][\s]*(?<desc>.+)[\s]*\<(?<val>.*)\>[\s]*'(?<def>.*)'/", $zeile, $res);
                    if (!in_array($res['name'], $config_values) && ($res['bez'] == $letter || $res['bez'] == "p" || $res['bez'] == "*"))
                        echo "<script>
                            var extra_tooltip=document.getElementById('extra_tooltip');
                            extra_tooltip.innerHTML=extra_tooltip.innerHTML+'<p>" . DIALPLAN_OPTION_DIS . "<b>&nbsp;" . $res['name'] . "</b><br>" . DIALPLAN_VALUES_DIS . "<b>&nbsp;&lt;" . $res['val'] . "&gt;</b><br>Default:<b>&nbsp;" . $res['def'] . "</b><br><i>" . htmlspecialchars($res['desc'], ENT_QUOTES) . "</i></p><br>';
			</script>";
                }
            }
            $ba = new beroAri();
            $query = $ba->select("select config from " . $table . " where gr='" . $_GET['gr'] . "' group by gr");
            while ($entry = $ba->fetch_array($query)) {
                $config = $entry['config'];
            }
            if ($config != "") {
                $configs = explode(',', $config);
                foreach ($configs as $value) {
                    $key = explode('=', $value, 2);
                    if ($key[0] != "" && $key[1] != "" && !in_array($key[0], $config_values)) {
                        echo "<script>var addit_options=document.getElementById('addit_options');
                            	if (addit_options.innerHTML=='')
                                    addit_options.innerHTML='" . $key[0] . "=" . $key[1] . "';
				else
                                    addit_options.innerHTML=addit_options.innerHTML+'\\n" . $key[0] . "=" . $key[1] . "';</script>";
                    } elseif ($key[0] != "" && $key[1] == "" && !in_array($key[0], $config_values)) {
                        echo "<script>var addit_options=document.getElementById('addit_options');
                                    if (addit_options.innerHTML=='')
                                        addit_options.innerHTML='" . $key[0] . "=';
                                    else
                                        addit_options.innerHTML=addit_options.innerHTML+'\\n" . $key[0] . "=';</script>";
                    }
                }
            }
        }
    }

    function show_confadd($config_values, $letter) {
        $isgw = new isgwtelnet();
        $result = $isgw->isgw_login();
        if ($result != false) {

            $dialplanc = $isgw->isgw_dialplanconfig();
            $zeilen = explode("\n", $dialplanc);
            foreach ($zeilen as $zeile) {
                if (stripos($zeile, '[') === 0) {
                    preg_match("/\[(?<bez>.+)\]\[(?<name>.+)\][\s]*(?<desc>.+)[\s]*\<(?<val>.*)\>[\s]*'(?<def>.*)'/", $zeile, $res);
                    if (!in_array($res['name'], $config_values) && ($res['bez'] == $letter || $res['bez'] == "p" || $res['bez'] == "*"))
                        echo "<script>
				var extra_tooltip=document.getElementById('extra_tooltip');
				extra_tooltip.innerHTML=extra_tooltip.innerHTML+'<p>" . DIALPLAN_OPTION_DIS . "<b>&nbsp;" . $res['name'] . "</b><br>" . DIALPLAN_VALUES_DIS . "<b>&nbsp;&lt;" . $res['val'] . "&gt;</b><br>Default:<b>&nbsp;" . $res['def'] . "</b><br><i>" . htmlspecialchars($res['desc'], ENT_QUOTES) . "</i></p><br>';
				var addit_options=document.getElementById('addit_options');
				if (addit_options.innerHTML=='')
                                    addit_options.innerHTML='" . $res['name'] . "=" . $res['def'] . "';
				else
                                    addit_options.innerHTML=addit_options.innerHTML+'\\n" . $res['name'] . "=" . $res['def'] . "';
			</script>";
                }
            }
        }
    }

}
