<?php

if (!defined('_BEROARI_CLASS')) {
	define('_BEROARI_CLASS', true);

	class beroAri {

		private $db;
		private $err;
                private $fxo_counter;
                        		function __construct ($path = '') {

                        
			$dbfile = (($path != '') ? $path : '/usr/conf/ari.db');

			if (is_file($dbfile) && filesize($dbfile)) {
				$this->db = sqlite_open($dbfile);
			} else {
				$this->db = sqlite_open($dbfile, 0666, $sqlerror);
				$this->create_database();
			}

			if ($this->db == null) {
				$this->err = 'Opening ' . $dbfile . ' failed: ' . sqlite_error_string(sqlite_last_error($this->db));
			}
                        
                        $this->fxo_counter=  $this->get_fxo_counter();
		}

		function __destruct() {
			if ($this->db) {
				sqlite_close($this->db);
			}
		}

		private function _add_module_isdn ($name, $lino, $portcount, $master, $clock) {

			$type = (($name == 'E1') ? 'P' : 'B') . 'RI';

			for ($i = 0; $i < $portcount; $i++) {
				$ret[] = 'INSERT INTO isdn (type, lif, master, config, port_type, clock) ' .
					 'VALUES (\'bf' . $portcount . $name . '\',\'' . $lino . '\',\'' . $master . '\',\'\',\'' . $type . '\',\'' . $clock[$i] . '\');';
			}

			return($ret);
		}

		private function _add_module_tel ($type, $lino, $portcount, $master) {

			switch($type) {
			case 'FXS':
			case 'FXO':
				$table = 'analog';
				break;
			case 'GSM':
				$table = 'gsm';
				break;
			default:
				return(array(NULL));
			}

			for ($i = 0; $i < $portcount; $i++) {
				$ret[] = 'INSERT INTO ' . $table . ' (type, lif, master, config, port_type) ' .
					 'VALUES (\'bf' . $portcount . $type . '\',\'' . $lino . '\',\'' . $master . '\',\'\',\'' . $type . '\');';
			}

			return($ret);
		}

		private function _add_module_t1 ($lino, $portcount, $master) {

			for ($i = 0; $i < $portcount; $i++) {
				sqlite_query($this->db, 'INSERT INTO cas (type, lif, master) VALUES (\'bf' . $portcount . 't1e1\',\'' . $lino . '\',\'' . $master . '\');');
				$port = sqlite_last_insert_rowid($this->db);

                                $ret[] = 'INSERT INTO isdn (type, lif, master, port_type,ccs) ' .
                                'VALUES (\'bf' . $portcount . 't1e1\',\'' . $lino . '\',\'0\',\'PRI\',1);';
			}

			return($ret);
		}

		private function _add_module_s0fxs ($lino, $portcount_s0, $portcount_fxs, $master, $clock) {

			for ($i = 0; $i < $portcount_s0; $i++) {
				$ret[] = 'INSERT INTO isdn (type, lif, master, config, port_type, clock) ' .
					 'VALUES (\'bf2S02FXS\',\'' . $lino . '\',\'' . $master . '\',\'\',\'BRI\',\'' . $clock[$i] . '\');';
			}

			for ($i = 0; $i < $portcount_fxs; $i++) {
				$ret[] = 'INSERT INTO analog (type, lif, master, config, port_type) ' .
					 'VALUES (\'bf2S02FXS\',\'' . $lino . '\',\'' . $master . '\',\'\',\'FXS\');';
			}

			return($ret);
		}

		function add_module_db ($lino, $master, $clock) {

			preg_match('/type: (?<li' . $lino . '>.*)/', file_get_contents('/proc/li' . $lino), $matches);
			$li = array('index' => $lino, 'name' => $matches['li' . $lino]);
			unset($matches);

			$ret = array();

			switch ($li['name']) {
			case 'xhfc-1su':
				$ret = array_merge($ret, $this->_add_module_isdn('S0', $li['index'], 1, $master, array($clock)));
				break;
			case 'xhfc-2su':
				$ret = array_merge($ret, $this->_add_module_isdn('S0', $li['index'], 2, $master, array($clock, 0)));
				break;
			case 'xhfc-4su':
				$ret = array_merge($ret, $this->_add_module_isdn('S0', $li['index'], 4, $master, array($clock, 0, 0, 0)));
				break;
			case 'hfc-e1':
				$ret = array_merge($ret, $this->_add_module_isdn('E1', $li['index'], 1, $master, array($clock)));
				break;
			case 'hfc-2e1':
				$ret = array_merge($ret, $this->_add_module_isdn('E1', $li['index'], 2, $master, array($clock, 0)));
				break;
			case 'telit-1GSM':
				$ret = array_merge($ret, $this->_add_module_tel('GSM', $li['index'], 1, 1));
				break;
			case 'telit-2GSM':
				$ret = array_merge($ret, $this->_add_module_tel('GSM', $li['index'], 2, 1));
				break;
			case 'si-1fxs':
				$ret = array_merge($ret, $this->_add_module_tel('FXS', $li['index'], 1, $master));
				break;
			case 'si-4fxs':
				$ret = array_merge($ret, $this->_add_module_tel('FXS', $li['index'], 4, $master));
				break;
			case 'si-8fxs':
				$ret = array_merge($ret, $this->_add_module_tel('FXS', $li['index'], 8, $master));
				break;
			case 'si-2fxo':
                                $this->fxo_counter++;
                                ($this->fxo_counter==2) ? $master=0 : $master=1;
				$ret = array_merge($ret, $this->_add_module_tel('FXO', $li['index'], 2, $master));
				break;
			case 'si-4fxo':
                                $this->fxo_counter++;
                                ($this->fxo_counter==2) ? $master=0 : $master=1;
				$ret = array_merge($ret, $this->_add_module_tel('FXO', $li['index'], 4, $master));
				break;
			case 'xhfcSi-2s02fxs':
				$ret = array_merge($ret, $this->_add_module_s0fxs($li['index'], 2, 2, $master, array($clock, 0)));
				break;
			case 'falc-1t1e1':
				$ret = array_merge($ret, $this->_add_module_t1($li['index'], 1, $master));
				break;
			case 'falc-2t1e1':
				$ret = array_merge($ret, $this->_add_module_t1($li['index'], 2, $master));
				break;
			case 'falc-4t1e1':
				$ret = array_merge($ret, $this->_add_module_t1($li['index'], 4, $master));
				break;
			}

			return($ret);
		}
                
                function get_fxo_counter (){
                    $result=@sqlite_query($this->db,"select distinct lif from analog where port_type='FXO'");
                    if ($result){
                        return sqlite_num_rows($result);
                    }else{
                       return 0;
                    }
                }

                function get_count_port ($lino) {

			preg_match('/type: (?<li' . $lino . '>.*)/', file_get_contents('/proc/li' . $lino), $matches);
			$li = array('index' => $lino, 'name' => $matches['li' . $lino]);
			unset($matches);

			switch ($li['name']) {
			case 'xhfc-1su':
                        case 'hfc-e1':
                        case 'telit-1GSM':
                        case 'si-1fxs':
                        case 'falc-1t1e1':
				$ret = 1;
				break;
			case 'xhfc-2su':
                        case 'hfc-2e1':
                        case 'telit-2GSM':
                        case 'si-2fxo':
                        case 'falc-2t1e1':
				$ret = 2;
				break;
			case 'xhfc-4su':
                        case 'si-4fxs':
                        case 'si-4fxo':
                        case 'xhfcSi-2s02fxs':
                        case 'falc-4t1e1':
				$ret = 4;
				break;
			case 'si-8fxs':
				$ret = 8;
				break;
			}

			return($ret);
		}

		function add_modules_db () {

			$queries_li[0] = $this->add_module_db(0, 1, 1);
			$queries_li[1] = $this->add_module_db(1, 0, 0);

			for ($i = 0; $i < 2; $i++) {
				if (!empty($queries_li[$i])) {
					foreach ($queries_li[$i] as $query) {
						sqlite_query($this->db, $query);
					}
					unset($queries_li[$i]);
				}
			}
		}

		function enable_portswitch () {

			$q = sqlite_query($this->db, 'SELECT type, lif FROM isdn union SELECT type, lif FROM analog union SELECT type, lif FROM gsm order by lif');

			while ($ent = sqlite_fetch_array($q)) {
				$li[$ent['lif']] = $ent['lif'];
				$type[$ent['lif']] = $ent['type'];
			}
			unset($q);

			$res = file_get_contents('/proc/cmdline');
			preg_match('/.*revision=(?<revision>.*)/', $res, $matches);
			$revision = $matches['revision'];
			unset($matches);

			if ((in_array($type[0], array('bf4S0', 'bf2S02FXS', 'bf4FXS', 'bf4FXO'))) && !isset($type[1]) && (strpos($revision, '1.8') == FALSE)) {
				sqlite_query($this->db, 'SELECT type, lif FROM isdn GROUP BY type, lif ORDER BY lif');
				sqlite_query($this->db, 'INSERT into key_val VALUES(\'portswitch\',1)');
			}
		}

		private function _import_sql ($filename) {

			if (!file_exists($filename)) {
				return(false);
			}

			foreach (file($filename) as $line) {
				if (($line[0] == '#') || (strlen($line) == 0)) {
					continue;
				}

				sqlite_query($this->db, $line);
			}

			return(true);
		}

		function create_database () {

			$this->_import_sql('/usr/local/conf/db/database_init.sql');
			$this->add_modules_db();

			if (@copy('/usr/local/conf/isgw.causes', '/tmp/isgw.causes')) {
				@include('./misc/ini_to_db_functions.php');

				$dir = getcwd();
				chdir('/usr/conf');
				if (!is_dir('backup')) {
					mkdir('backup');
				}

				copy('isgw.causes', 'backup/isgw.causes');
				unlink('isgw.causes');

				if (is_file('/tmp/isgw.causes')) {
					copy('/tmp/isgw.causes', '/usr/conf/isgw.causes');
				}

				$db = new beroAri();
				if (!isgwcauses_initoDB($db, $strpath, 1)) {
					$this->_import_sql('/usr/local/conf/db/database_init_causes.sql');
				}
				chdir($dir);
			} else {
				$this->_import_sql('/usr/local/conf/db/database_init_causes.sql');
			}

			$this->enable_portswitch();
		}

		private function _generic_query ($sql) {
			if (($res = @sqlite_query($this->db, $sql)) == false) {
				$this->err = 'query(' . $sql . ') failed: ' . sqlite_error_string(sqlite_last_error($this->db));
				return(false);
			}

			return($res);
		}

		function update ($sql) {
			return($this->_generic_query($sql));
		}

		function delete ($sql) {
			return($this->_generic_query($sql));
		}

		function insert_($sql) {
			return($this->_generic_query($sql));
		}

		function select($sql) {
			return($this->_generic_query($sql));
		}

		function exec_query($sql) {
			return($this->_generic_query($sql));
		}

		function set($key, $value = '') {
			$sql = 'UPDATE key_val SET value = \'' . sqlite_escape_string($value) . '\' WHERE key = \'' . $key . '\'';
			if (($ok = sqlite_exec($this->db, $sql)) == false) {
				return false;
			}

			if (sqlite_changes($this->db) == 1) {
				return true;
			}

			$sql = 'INSERT INTO key_val (key, value) VALUES (\'' . $key . '\', \'' . $value . '\')';

			return((sqlite_exec($this->db, $sql) == false) ? false : true);
		}

		function get($key) {
			$sql = 'SELECT value FROM key_val WHERE key = \'' . $key . '\';';
			$res = sqlite_query($this->db, $sql);
			if (($res == false) || (($row = $this->fetch_array($res)) == false)) {
				return false;
			}

			return $row[0];
		}

		function stripslashes_deep($value) {
			return(is_array($value) ? array_map(array($this, 'stripslashes_deep'), $value) : stripslashes($value));
		}

		function htmlentities_deep($value) {
			return(is_array($value) ? array_map(array($this, 'htmlentities_deep'), $value) : htmlentities($value, ENT_NOQUOTES));
		}

		function fetch_array($data) {
			$entry = sqlite_fetch_array($data);
			$entry = $this->stripslashes_deep($entry);
			return($this->htmlentities_deep($entry));
		}

		function rowid() {
			return(sqlite_last_insert_rowid($this->db));
		}

		function column_type($data) {
			return(sqlite_fetch_column_types($data, $this->db));
		}

		function is_error() {
			return($this->err ? true : false);
		}

		function error() {
			return($this->err ? $this->err : 'No error.');
		}
	}
} // END DEFINE _BEROARI_CLASS
